# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['SchematicArgs', 'Schematic']

@pulumi.input_type
class SchematicArgs:
    def __init__(__self__, *,
                 schematic: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Schematic resource.
        :param pulumi.Input[str] schematic: The schematic yaml respresentation to generate the image.
        """
        if schematic is not None:
            pulumi.set(__self__, "schematic", schematic)

    @property
    @pulumi.getter
    def schematic(self) -> Optional[pulumi.Input[str]]:
        """
        The schematic yaml respresentation to generate the image.
        """
        return pulumi.get(self, "schematic")

    @schematic.setter
    def schematic(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "schematic", value)


@pulumi.input_type
class _SchematicState:
    def __init__(__self__, *,
                 schematic: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Schematic resources.
        :param pulumi.Input[str] schematic: The schematic yaml respresentation to generate the image.
        """
        if schematic is not None:
            pulumi.set(__self__, "schematic", schematic)

    @property
    @pulumi.getter
    def schematic(self) -> Optional[pulumi.Input[str]]:
        """
        The schematic yaml respresentation to generate the image.
        """
        return pulumi.get(self, "schematic")

    @schematic.setter
    def schematic(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "schematic", value)


class Schematic(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 schematic: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The image factory schematic resource allows you to create a schematic for a Talos image.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] schematic: The schematic yaml respresentation to generate the image.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[SchematicArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The image factory schematic resource allows you to create a schematic for a Talos image.

        :param str resource_name: The name of the resource.
        :param SchematicArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SchematicArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 schematic: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SchematicArgs.__new__(SchematicArgs)

            __props__.__dict__["schematic"] = schematic
        super(Schematic, __self__).__init__(
            'talos:imageFactory/schematic:Schematic',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            schematic: Optional[pulumi.Input[str]] = None) -> 'Schematic':
        """
        Get an existing Schematic resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] schematic: The schematic yaml respresentation to generate the image.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SchematicState.__new__(_SchematicState)

        __props__.__dict__["schematic"] = schematic
        return Schematic(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def schematic(self) -> pulumi.Output[Optional[str]]:
        """
        The schematic yaml respresentation to generate the image.
        """
        return pulumi.get(self, "schematic")

